function tank_secant ()
  m = 200 ;
  a0=1 ;
  b0=5 ;
  [xx,yy] = plotinit(m,a0,b0) ;


  %%x = zeros(1,100) ;
  %%f_d = zeros(1,100) ;

  %% Set the bracket
  x(1) = a0 ;
  x(2) = b0 ;


  %% Compute gradients
  f_d(1) = sTank_d( x(1) ) ;
  f_d(2) = sTank_d( x(2) ) ;

  %% Set tolerance for the gradient
  eps = 1.e-7 ;


  printf ( "%4s %7s %7s %10s %10s %8s\n", 
           "iter", "x-2", "x-1", "x", "f'", "f" ) ;
  k = 2 ;
  do
    k++ ;

    x(k) = x(k-2) - f_d(k-2)/( f_d(k-1) - f_d(k-2) )*( x(k-1)-x(k-2) ) ;
    f_d(k) = sTank_d( x(k) ) ;
    fmin = sTank( x(k) ) ;

    printf ( "%4i, %7.4f %7.4f %9.6f; %9.6f %9.6f\n", 
             k, x(k-2), x(k-1), x(k), f_d(k), fmin ) ;

    if ( k<10)
      flnm = char ( ["tank-sec-",48+k,".svg"] ) ;
      plotsec ( xx, yy, x(k-2), f_d(k-2), x(k-1), f_d(k-1), x(k), flnm ) ;
    endif

  until ( abs( f_d(k) ) < eps | k > 99 ) 

endfunction


function surface = sTank (x)
  vStar = 5 ;
  surface = 4*vStar/x + x^2 ;
endfunction


function surface_d = sTank_d (x)
  vStar = 5 ;
  %%  surface = 4*vStar/x + x^2 ;
  surface_d = -4*vStar/x^2 + 2*x ;
endfunction

function [x,y] = plotinit (m,a0,b0)
  %% plot continous function.
  x = linspace(a0,b0,m);
  for i=1:m 
    y(i) = sTank(x(i)) ;
  endfor
endfunction


function plotsec ( x, y, xm2, fdm2, xm1, fdm1, xm0, flnm ) 
  hold off
  plot(x,y, "linewidth", 2)
  axis([1,5,10,30]) ;

  ax = gca ();
  set (ax, "linewidth", 2 ) ;
  xlabel("x_2")
  ylabel("S")
  hold on


  %% left gradient
  plot ( xm2, sTank(xm2), "ks", "linewidth", 2 ) ;
  d = .5 ;
  x0 = xm2 ;
  g0 = fdm2 ;  
  z = [ x0-d, x0+d ] ;
  yz = [ sTank(x0)-d*g0, sTank(x0)+d*g0];
  plot ( z, yz, "k", "linewidth", 1 ) ;
  

  %% right gradient
  plot ( xm1, sTank(xm1), "ks", "linewidth", 2 ) ;
  d = .5 ;
  x0 = xm1 ;
  g0 = fdm1 ;  
  z = [ x0-d, x0+d ] ;
  yz = [ sTank(x0)-d*g0, sTank(x0)+d*g0];
  plot ( z, yz, "k", "linewidth", 1 ) ;

  %% right gradient
  plot ( xm0, sTank(xm0), "rs", "linewidth", 2 ) ;


  %% why does iti work to build the filename in main and pass, but
  %% not to build it here?
  %% Ascii code for 0 is 48?
  %%  flnm = char ( ["tank-sec-",48+k,".svg"] ) ;
  print ( flnm, '-dsvg', '-landscape' )
  %% best plots for presentation is svg, then convert to png.
  %%  print ( flnm, '-dpng', '-F:128', '-landscape' )

  pause

endfunction

