
function tank_secant_b ()

%% Set the bracket
x(1) = 1. ;
x(2) = 5. ;

%% Compute gradients
f_d(1) = sTank_d( x(1) ) ;
f_d(2) = sTank_d( x(2) ) ;

%% Set tolerance for the gradient
eps = 1.e-7 ;


  printf ( "%4s %7s %7s %10s %10s %8s\n", 
          "iter", "x-2", "x-1", "x", "f'", "f" ) ;
k = 2 ;
do
  k++ ;

  if ( k > 3 )
    %% Version a): choose smalles f_d
    if ( abs( f_d(k-3) ) < abs( f_d(k-2) ) )
%%    %% Version b): choose other sign for f_d
%%    if ( f_d(k-1)*f_d(k-2) < 0 &  f_d(k-1)*f_d(k-3) > 0 )
      x(k-2) = x(k-3) ; 
      f_d(k-2) = f_d(k-3) ;
    endif 
  endif

  x(k) = x(k-2) - f_d(k-2)/( f_d(k-1) - f_d(k-2) )*( x(k-1)-x(k-2) ) ;
  f_d(k) = sTank_d( x(k) ) ;
  fmin = sTank( x(k) ) ;

  printf ( "%%4i, %7.4f %7.4f %9.6f; %9.6f %9.6f\n", 
          k, x(k-2), x(k-1), x(k), f_d(k), fmin ) ;

until ( abs( f_d(k) ) < eps | k > 99 ) 

endfunction


function surface = sTank (x)
  vStar = 5 ;
  surface = 4*vStar/x + x^2 ;
endfunction


function surface_d = sTank_d (x)
  vStar = 5 ;
%  surface = 4*vStar/x + x^2 ;
  surface_d = -4*vStar/x^2 + 2*x ;
endfunction
